﻿#NoTrayIcon
#SingleInstance force
SetWorkingDir %A_ScriptDir%
SplitPath,A_ScriptName,,,,Title

Gui, Add, StatusBar,, Enter text to verify!
Gui, Add, GroupBox, vBOX x6 y-3 h110
Gui, Font, S14 CDefault, Courier New
Gui, Add, Edit, vEINS gEnter limit99 -wrap x16 y17 h30 , #1
Gui, Add, Edit, vZWEI hwndZWEIID gEnter limit99 -wrap x16 y57 w500 h30 , #2
Control_Colors("0xFFFFFF", "0x000000", "Set", ZWEIID)

Gui, Add, Text, vText1 y20 w25 h20 , 99
Gui, Add, Text, vText2 y60 w25 h20 , 99
Gui, Font, S08 CDefault, Verdana

Gui, Add, GroupBox, x6 y110 h42 w220
Gui, Add, CheckBox, vUpDownCheck gGUItexts x22 y120 w10 h30
Gui, Add, Text, vUpDownText x42 y126 w160 h15, Auto-Hyphen after 5 chars
Gui, Add, UpDown, -16 gGUItexts vUpDown x200 y125 h20 range2-20, 5

Gui, Add, GroupBox, x230 y110 h42 w95
Gui, Add, CheckBox, gGUItexts vCaps x240 y120 w10 h30,
Gui, Add, Text, vCapsText x257 y126 w65 h15, All Caps

Gui, Add, GroupBox, x330 y110 h42 w95
Gui, Add, CheckBox, gGUItexts vLog x340 y120 w10 h30,
Gui, Add, Text, vLogText x357 y126 w65 h15, Write Log

Gui, Add, GroupBox, x430 y110 h42 w95
Gui, Add, CheckBox, gGUItexts vOnTop x440 y120 w10 h30,
Gui, Add, Text, vonTopText x457 y126 w65 h15, OnTop

Gosub,GUItexts

Gui, +Resize -Minimizebox -Maximizebox +MinSize +MinSize540x +MaxSize +MaxSize1200x
Gui, Show, Autosize Center, %Title%
Return

GuiEscape:
GuiClose:
ExitApp




GUItexts:
Gui,Submit,Nohide
GuiControl,% (OnTop = 1) ? "Enable":"Disable", OnTopText
WinSet,AlwaysOnTop,% (OnTop = 1) ? "On":"Off",A
GuiControl,% (Caps = 1) ? "Enable":"Disable", CapsText
GuiControl,% (Log = 1) ? "Enable":"Disable", LogText
GuiControl,% (UpDownCheck = 1) ? "Enable":"Disable", UpDown
GuiControl,% (UpDownCheck = 1) ? "Enable":"Disable", UpDownText
GuiControl,,UpDownText,% "Auto-Hyphen after " . UpDown . " chars"
If (Log = 1)
	SB_SetText("Log enabled. Press CTRL+L to open log in Notepad.") 
Return




GuiSize:
If A_EventInfo = 1
	Return
GuiControl, Move, BOX, % "w" (A_guiwidth-75) 
GuiControl, Move, EINS, % "w" (A_guiwidth-100) 
GuiControl, Move, ZWEI, % "w" (A_guiwidth-100) 
GuiControl, Move, TEXT1, % "x" (A_guiwidth-50) 
GuiControl, Move, TEXT2, % "x" (A_guiwidth-50) 
Return




Enter:
Gui,Submit,NoHide
UpDown += 1
StringLen, Laenge, Eins
GuiControl,,Text1,%Laenge%
if Eins = 
	GuiControl,,Text1,
if Eins = #1
	GuiControl,,Text1,

StringSplit,Split,Eins,-
Gosub,HyphenCheck

StringLen, Laenge, Zwei
GuiControl,,Text2,%Laenge%
if Zwei = 
	GuiControl,,Text2,
if Zwei = #2
	GuiControl,,Text2,

StringSplit,Split,Zwei,-
Gosub,HyphenCheck

StringCaseSense,On
if zwei = #2
{
	Control_Colors("0xFFFFFF", "0x000000", "Set", ZWEIID)
	WinSet, Redraw, , ahk_id %ZWEIID%
	SB_SetText("Enter text to verify!")
	Return
}
if zwei = 
{
	Control_Colors("0xFFFFFF", "0x000000", "Set", ZWEIID)
	WinSet, Redraw, , ahk_id %ZWEIID%
	SB_SetText("Enter text to verify!")
	Return
}
if zwei <> %EINS%
{
	FirstDiff := ""
	Control_Colors("0x0000FF", "0x000000", "Set", ZWEIID)
	WinSet, Redraw, , ahk_id %ZWEIID%
	Loop,99
	{
		If (SubStr(Eins,A_Index,1) <> SubStr(Zwei,A_Index,1))
		{
			FirstDiff := "No match in position " . A_Index . " !"
			Break
		}
	}
	If SetClipboard = 1
	{
		SB_SetText( ((FirstDiff = "") ? "No match!":FirstDiff) . " (Clipboard cleared!)")
		Clipboard =
		SetClipboard =
	}
	else
		SB_SetText((FirstDiff = "") ? "No match!":FirstDiff)
	Return
}
if zwei = %EINS%
{
	Control_Colors("0x008000", "0x000000", "Set", ZWEIID)
	WinSet, Redraw, , ahk_id %ZWEIID%
	Clipboard := Zwei
	SetClipboard = 1
	SB_SetText("Match! (Copied to clipboard" . ((Log=1) ? " and written to LOG file." : "!") . ")")

	If (Log = 1)
	{
		Loop,Read,%title%.log
			lastlinelog := A_LoopReadLine
		If (Zwei = LastLineLog)
			Return
		FileAppend,% (Trim(LastLineLog) = "" ? "" : "`n") . Zwei, %title%.log
	}	
}
StringCaseSense,Off
Return




HyphenCheck:
If (UpDownCheck = 1)
{
	If (Split0 = 1 and Laenge = UpDown)
		SendInput,{left}-{right}
	else
	{
		StringLen,LaengeSplit,Split%Split0%
		If (LaengeSplit = UpDown)
			SendInput,{left}-{right}
	}
}
Return




#If (WinActive(title) And Caps = 1)
a::A
b::B
c::C
d::D
e::E
f::F
g::G
h::H
i::I
j::J
k::K
l::L
m::M
n::N
o::O
p::P
q::Q
r::R
s::S
t::T
u::U
v::V
w::W
x::X
y::Y
z::Z
#If




#If WinActive(Title)
^l::
Run,Notepad "%title%.log"
Return
AppsKey::
SB_SetText("Sorry, Apps Key not allowed!")
Return
^v::
+ins::
SB_SetText("Sorry, pasting from clipboard not allowed!")
Return
RButton::
SB_SetText("Sorry, right click not allowed!" . A_GuiControl)
Return
^c::
!ins::
send,^c
SB_SetText("Copied """ . Clipboard . """ to clipboard!")
Return
#If




; ------------------------------------------------------------------------------
; Control_Colors function by "derRaphael" and "denick"
; http://de.autohotkey.com/forum/topic2570.html
; ------------------------------------------------------------------------------                                                                                                                       
Control_Colors(wParam, lParam, Msg, Hwnd) {
   Static Init := True    
   Static SetVal := "Set" 
   Static ValLst := ""    
   Static RX := "\|(?P<B>0x[[:xdigit:]]{6})\|(?P<T>[*0]x[[:xdigit:]]{6})$"
   Static Default := "*x000000"
   Static WM_CTLCOLOREDIT := 0x0133
   Static WM_CTLCOLORLISTBOX := 0x134
   Static WM_CTLCOLORSTATIC := 0x0138
   Static BRUSH := 0
   Critical
   Format_I := A_FormatInteger
   SetFormat, Integer, H
   If (Init) {
      OnMessage(WM_CTLCOLOREDIT, "Control_Colors")
      OnMessage(WM_CTLCOLORLISTBOX, "Control_Colors")
      OnMessage(WM_CTLCOLORSTATIC, "Control_Colors")
      OnMessage(WM_CTLCOLORMSGBOX, "Control_Colors")
      Init := False
   }
   If (Msg = SetVal) {
      If !(Hwnd + 0) {
        GuiControlGet, nHwnd, Hwnd, %Hwnd%
        Hwnd := nHwnd
      }
      W := (SubStr(wParam, 1, 1) = "*") ? Default
         : "0x" SubStr("000000" SubStr(wParam + 0, 3), -5)
      L := (W = Default) ? Default
         : (SubStr(lParam, 1, 1) = "*") ? Default
         : "0x" SubStr("000000" SubStr(lParam + 0, 3), -5)
      H := Hwnd + 0
      If (RegExMatch(ValLst, "Sm)^" H "\|"))
         ValLst := RegExReplace(ValLst, "Sm)^" H "\|.*$", H "|" W "|" L)
      Else
         ValLst .= H "|" W "|" L "`r`n"
      SetFormat, Integer, %Format_I%
      Return
   }
   If (RegExMatch(ValLst, "Sim)^" (lParam + 0) RX, C)) {
      If (BRUSH) {
         DllCall("DeleteObject", UInt, BRUSH)
         BRUSH := 0
      }
      If (CT != Default)
         DllCall("SetTextColor", UInt, wParam, UInt, CT)
      DllCall("SetBkColor", UInt, wParam, UInt, CB)
      SetFormat, Integer, %Format_I%
      Return (BRUSH := DllCall("CreateSolidBrush", UInt, CB))
   }
   SetFormat, Integer, %Format_I%
}